#ifndef _ONINSTANCECMD_H
#define _ONINSTANCECMD_H


// Internal enum
enum OnInstanceCmd {
    parentCmd = 0,
    childrenCmd  = 1,
    getDefCmd = 2,
    getUmlDefCmd  = 3,
    getCppDefCmd = 4,
    getJavaDefCmd = 5,
    getIdlDefCmd = 6,
    isWritableCmd = 7,
    supportFileCmd = 8,
    isOpenCmd =9 ,
    setOpenCmd =10,
    assocComponentCmd =11,
    assocArtifactCmd =12,
    saveInCmd  =13,
    formalsCmd  =14,
    actualsCmd = 15,
    cppBodyCmd =16,
    javaBodyCmd =17,
    applyCmd=18,
    referencedByCmd=19,
    sideCmd = 20,
    attributesCmd = 21,
    relationsCmd = 22,
    getPhpDefCmd = 23,
    phpBodyCmd = 24,
    getPythonDefCmd = 25,
    pythonBodyCmd = 26,
    firstSetCmd = 50, // just a mark
    createCmd = 51,
    setCoupleValueCmd = 52,
    setDescriptionCmd = 53,
    setNameCmd = 54,
    setStereotypeCmd = 55,
    addAssocClassCmd = 56,
    removeAssocClassCmd  = 57,
    setAssocClassesCmd  = 58,
    setAssocDiagramCmd = 59,
    setAssocViewCmd = 60,
    addGetOperCmd,
    addSetOperCmd,
    setIsClassMemberCmd,
    setVisibilityCmd,
    setCppDeclCmd,
    setCppDefCmd,
    setJavaDeclCmd,
    setIdlDeclCmd,
    setCppVisibilityCmd,
    setIsReadOnlyCmd,
    setDefaultValueCmd,
    setTypeCmd,
    setIsVolatileCmd,
    setIsCppMutableCmd,
    setIsJavaTransientCmd,
    setIdlCaseCmd,
    setIsCppInlineCmd,
    setIsAbstractCmd,
    setBaseTypeCmd,
    setIsCppExternalCmd,
    setIsJavaExternalCmd,
    setIsIdlExternalCmd,
    setIsJavaPublicCmd,
    setIsJavaFinalCmd,
    setIsIdlLocalCmd,
    setIsIdlCustomCmd,
    setSwitchTypeCmd,
    removeFormalCmd,
    addFormalCmd,
    replaceFormalCmd,
    replaceActualCmd,
    setCppHCmd,
    setCppSrcCmd,
    setJavaSrcCmd,
    setIdlSrcCmd,
    addAssocArtifactCmd,
    removeAssocArtifactCmd,
    removeAllAssocArtifactsCmd,
    setReturnTypeCmd,
    setIsCppConstCmd,
    setIsCppFriendCmd,
    setIsCppVirtualCmd,
    setIsCppDefaultCmd,
    setIsCppDeleteCmd,
    setIsCppOverrideCmd,
    setIsCppFinalCmd,
    setIsIdlTruncatableCmd,
    setCppBodyCmd,
    setCppNameSpecCmd,
    setJavaFinalCmd,
    setJavaSynchronizedCmd,
    setJavaBodyCmd,
    setJavaNameSpecCmd,
    setIsIdlOnewayCmd,
    setIdlNameSpecCmd,
    addParameterCmd,
    removeParameterCmd,
    replaceParameterCmd,
    addExceptionCmd,
    removeExceptionCmd,
    replaceExceptionCmd,
    setCppSrcDirCmd,
    setCppHDirCmd,
    setCppNamespaceCmd,
    setJavaDirCmd,
    setJavaPackageCmd,
    setIdlDirCmd,
    setIdlModuleCmd,
    setRoleNameCmd,
    setMultiplicityCmd,
    setCppVirtualInheritanceCmd,
    setMarkedCmd,
    setUmlEntryBehaviorCmd,
    setUmlExitBehaviorCmd,
    setUmlActivityCmd,
    setCppEntryBehaviorCmd,
    setCppExitBehaviorCmd,
    setCppActivityCmd,
    setJavaEntryBehaviorCmd,
    setJavaExitBehaviorCmd,
    setJavaActivityCmd,
    setUmlTriggerCmd,
    setUmlGuardCmd,
    setCppTriggerCmd,
    setCppGuardCmd,
    setJavaGuardCmd,
    setJavaTriggerCmd,
    setDefCmd,
    moveAfterCmd,
    setJavaAnnotationCmd,
    setRelationAssocClassCmd,
    setReadOnlyCmd,
    setSingleExecutionCmd,
    setUnmarshallCmd,
    setTimeEventCmd,
    setFlagCmd,
    setUniqueCmd,
    setStreamCmd,
    setInStateCmd,
    setOrderingCmd,
    setCppFrozenCmd,
    setJavaFrozenCmd,
    setIdlFrozenCmd,
    setConstraintCmd,
    deleteCmd,
    setAttributeCmd,
    addRelationCmd,
    removeRelationCmd,
    setPhpDeclCmd,
    setIsPhpExternalCmd,
    setIsPhpFinalCmd,
    setPhpSrcCmd,
    setPhpFinalCmd,
    setPhpBodyCmd,
    setPhpNameSpecCmd,
    setPhpDirCmd,
    setPhpFrozenCmd,
    setIsForceBodyGenCmd,
    setCppContextualBodyIndentCmd,
    setJavaContextualBodyIndentCmd,
    setPhpContextualBodyIndentCmd,
    setPythonDeclCmd,
    setIsPythonExternalCmd,
    setPythonSrcCmd,
    setPythonBodyCmd,
    setPythonNameSpecCmd,
    setPythonDirCmd,
    setPythonFrozenCmd,
    setIsPython2_2Cmd,
    setPythonDecoratorsCmd,
    setPythonPackageCmd,
    setPythonContextualBodyIndentCmd,
    applyStereotypeCmd,
    setDerivedCmd

};
#endif
